function x = solve(stub)
% sipsolve Solves semi-infinite programming problems using the
%   SIPAMPL interface. The sintax is
%       x=sipsolve(stub)
%
%   x is the solution to the sip. stub is the problem name (without
%     the filename extension)
%
[x0,ntc,xbl,xbu]=sipampl(stub);

options = optimset('GradObj', 'on', 'Diagnostics','on', 'display', 'iter');

x=fseminf('sipampl',x0,ntc,'sipampl',[],[],[],[],xbl,xbu,options);
%x=fseminf('sipampl',x0,ntc,'sipampl',[],[],[],[],xbl,xbu);

sipampl('Solution found by MATLAB',x);



