function [c,ceq,varargout]=sip_con(x,s,tbl,tbu)
% sip_con evaluates the finite and infinite constraints
%
%  28/11/2002 aivaz@dps.uminho.pt

if nargin < 2 | nargout<4
    error('Invalid number of arguments');
end

%number of infinite variables
NumberInfVars=length(tbl);

if isnan(s(1,1)),
    s=(tbu(1)-tbl(1))*0.01*ones(nargout-3,2);
end



% sanity checkup for quadratic interpolation
for i=1:nargout-3
    if((tbu(1)-tbl(1))/s( i,1)<4)
        s(i,1)=(tbu(1)-tbl(1))/4;
    end
    if NumberInfVars~=1
        if((tbu(2)-tbl(2))/s( i,2)<4)
            s(i,2)=(tbu(2)-tbl(2))/4;
        end
    end
end

varargout{nargout-2}=s;

for i=1:nargout-3
    if NumberInfVars ==1
        w1=tbl(1):s(i,1):tbu(1);
        lw1=length(w1);
    else
%        [w1,w2] = meshgrid(tbl(1):s(i,1):tbu(1),tbl(2):s(i,2):tbu(2));
        w1=tbl(1):s(i,1):tbu(1);
        w2=tbl(2):s(i,2):tbu(2);
        lw1=length(w1);
        lw2=length(w2); 
    end
    
    
    if NumberInfVars==1
        varargout{i}=zeros(1,lw1);
    else
        varargout{i}=zeros(lw2,lw1);
    end
   
    if NumberInfVars==1
        for j=1:lw1
            varargout{i}(j)=sip_contval(i-1,x,w1(j));
        end
    else
        for j=1:lw1
            for k=1:lw2
                varargout{i}(k,j)=sip_contval(i-1,x,[w1(j), w2(k)]);
            end
        end
    end
end

% we could avoid to compute the infinite constraints again
if NumberInfVars==1
    [c, ceq, inf] = sip_conval(x, w1(1));
else
    [c, ceq, inf] = sip_conval(x, [w1(1), w2(1)]);
end

