function [gx, gt]=sip_contgrd(n,x,t)
% sip_contgrd returns the infinite constraint n gradient at x,t
%
% In arguments:
%  n: constraint number
%  x: array of finite variables
%  t: array of infinite variables
%
% Out arguments:
%  gx: value of infinite constraint n gradient, w.r.t. x, at x,t
%  gt: value of infinite constraint n gradient, w.r.t. t, at x,t
%
%  13/11/2002 aivaz@dps.uminho.pt

if nargin ~= 3 | nargout ~=2
   warning('Incorrect number of arguments'); 
   sip_usage;
   error(' ');
   return
end

[gx, gt]=sipampl2(12, n, x, t);
