function [hx, ht, hxt]=sip_conthes(n)
% sip_conthes returns the infinite constraint n Hessian at x,t, the last value used in
%   calls to objective or constraints functions
%
% In arguments:
%  n: constraint number
%
% Out arguments:
%  hx: value of infinite constraint n Hessian, w.r.t. xx, at x,t
%  ht: value of infinite constraint n Hessian, w.r.t. tt, at x,t
%  hxt: value of infinite constraint n Hessian, w.r.t. xt, at x,t
%
%  13/11/2002 aivaz@dps.uminho.pt

if nargin ~= 1 | nargout ~=3
   warning('Incorrect number of arguments'); 
   sip_usage;
   error(' ');
   return
end

[hx, ht, hxt]=sipampl2(13, n);
