function [x, xbl, xbu, tbl, tbu]=sip_init(stub)
% sip_init initializes the use of the sipampl interface routines.
%
% In arguments:
%  stub: String with the filename of the .nl file to be solved
%
% Out arguments:
%  x: initial guess
%  xbl: lower bound array of the finite variables
%  xbu: upper bound array of the finite variables
%  tbl: lower bound array of the infinite variables
%  tbu: upper bound array of the infinite variables
%
%  13/11/2002 aivaz@dps.uminho.pt

if nargin ~= 1 | nargout ~=5
   warning('Incorrect number of arguments'); 
   sip_usage;
   error(' ');
   return
end

[x, xbl, xbu, tbl, tbu]=sipampl2(0,stub);
