function [jacc, jacceq, jactinf, jacxinf]=sip_jacval(x,t)
% sip_jacval returns the Jacobian at x,t.
%
% In arguments:
%  x: array of finite variables
%  t: array of infinite variables
%
% Out arguments:
%  jacc:  Jacobian of inequality finite constraints
%               (number of inequality constraints*number of finite variables)
%  jacceq:  Jacobian of equality finite constraints
%               (number of equality constraints*number of finite variables)
%  jactinf:  Jacobian of infinite constraints w.r.t. the infinite variables
%               (number of infinite constraints*number of infinite variables)
%  jacxinf:  Jacobian of infinite constraints w.r.t. the finite variables
%               (number of infinite constraints*number of finite variables)
%
%  13/11/2002 aivaz@dps.uminho.pt

if nargin ~= 2 | nargout ~=4
   warning('Incorrect number of arguments'); 
   sip_usage;
   error(' ');
   return
end

[jacc, jacceq, jactinf, jacxinf]=sipampl2(14, x, t);
