#include "solver.h"

extern SIP_S sip_s;
extern SSO Sip_Opt;
extern STATS stats;


int positivelag(int nl, double *lag);
double penaltyf_dual(int nx, double *x, int nl, double *lag, int nt, double *t,
		     double miu, double *pt, int dlevel, double *grad,
		     double *lgrad, double*jac);
void penaltyfs_dual();
void gpenaltyf_dual(int nx, double *x, int nl, double *lag, int nt, double *t,
		    double miu, double *dx, double *dl, double *fx,
		    double *pt, double*jac);
void set_h_dual(double *h, int k, int nx , double *x1, double *x0,
		int nl, double *lag1, double *lag0, double *g1, double *g0,
		double *lg1, double *lg0);
void set_hss(double *hss, int k, int nx , double *x1, double *x0,
	     double *g1, double *g0);
void get_dir_dual(int nx, double *x, int nl, double *lag, double *h,
		  double *grad, double *lgrad, double *dir, double*jac);
void armijo_dual(int nx, double *x0, int nl, double *lag0, double *dir,
		 double *x1, double *grad, double *lag1, double *glag,
		 double miu);


extern void identity(double *h, int nx);
extern void set_h(double *h, int k, int nx, double *x1, double *x0,
		  double *g1, double *g0);
extern int pf_i_stop(int nx, double *x0, double *x1, double *g1, double pt);
extern int pf_o_stop(int nx, double *x0, double *x1, double *g1, double pt);
extern int pf_eps_stop(int nx, double *x0, double *x1);
extern void scale_dir(int nx, double *dir);
extern void egpp(int n, double *a, double *b, double *x, int *singular);
extern double gxt(double *x, double *t, int j, int dlevel, double *grad,
		  double miu);
extern double gxtplus(double *x, double *t, int j, int dlevel, double *grad,
		      double miu);
extern double gxtplus2(double *x, double *t, int j, int dlevel, double *grad,
		       double miu);
extern double gxtepsilon(double *x, double *t, int j, int dlevel, double *grad,
			 double miu);
extern double gxtexpplus(double *x, double *t, int j, int dlevel, double *grad,
			 double miu);
extern double gxtexpepsilon(double *x, double *t, int j, int dlevel,
			    double *grad, double miu);
extern double gxtteo(double *x, double *t, int j, int dlevel, double *grad,
		     double miu);
extern double gxtexpteo(double *x, double *t, int j, int dlevel, double *grad,
			double miu);
extern double gxthart(double *x, double *t, int j, int dlevel, double *grad,
		      double miu);
extern double gxtgross(double *x, double *t, int j, int dlevel, double *grad,
		       double miu);

extern void printarray(double *a, int n);
extern void printmatrix(double *a, int n1, int n2);

extern int npsol_(long *n, long *nclin, long *ncnln, long *nrowa,
        long *nrowuj, long *nrowr, double *a, double *bl, double *bu,
        void (*confun) (), void (*objfun) (), long *inform, long *iter,
        long *istate, double *c, double *ujac, double *clamda, double *objf,
        double *ugrad, double *r, double *x, long *iw, long *leniw,
        double *w, long *lenw);

double solve_pf(void);
