/*******************************************************
 * Select tool header file
 ******************************************************/


/* objective and constraints allowed types */
enum {
  LINEAR,
  QUADRATIC,
  POLYNOMIAL,
  GENERIC,
  ALL
};

enum {
  BOTH,  /* both finite  */
  LOWER, /* lower finite,   upper infinite */
  UPPER, /* lower infinite, upper finite */
  NONE,  /* none finite  */
  ANY    /* everything   */
};

enum {
  INI_NO,    /* without initial guess */
  INI_YES,   /* with initial guess */
  INI_BOTH   /* with or without initial guess */
};



#define TRUE 1
#define FALSE 0



/* options supplied by user */
struct options {
  int obj_type;
  int cons_type;
  int nfin_var_lb;
  int nfin_var_ub;
  int ninf_var_lb;
  int ninf_var_ub;
  int nfin_cons_lb;
  int nfin_cons_ub;
  int ninf_cons_lb;
  int ninf_cons_ub;
  int boundx;
  int boundt;
  int initial_guess;
} options;

/* a list with the matched problems name */
struct match_file {
  char *filen;
  struct match_file *next;
} match_file;


/* the first of the list */
struct match_file *first_file;


/* expert mode */
int expert=0;


#if defined __linux__ || defined linux
char DATABASE[256]="../sipmod/";
char DEPOSIT[256]="../sipnl/";
char AMPL[256]="../ampl";
char TMP[256]="/tmp";
#else
char DATABASE[256]="..\\sipmod";
char DEPOSIT[256]="..\\sipnl";
char AMPL[256]="..\\ampl.exe";
char TMP[256]="c:\\windows\\temp";
#endif


void printoptions(void);
void printbound(int lb, int up, char *str);
void printbound_var(int type, char *str);
void printtype(int opt, char *str);
void printinitial(int opt, char *str);
int chgoptiontype(char *str);
void chgoptionbound(int *lb, int *ub, char *str);
int choptionbound_var(char *str);
int chgoptioninitial(char *str);
void *mymalloc_sel(int size);
int matchoptions(char *filen);
void printfiles(struct match_file *tmp, FILE *desc, char *fmt, int ext);
void tolowers(char *s);
void rmlowhite(char *tmpline, char *tmpclean);
FILE *myopen(char *filen);
